/**
 */
package org.etsi.mts.tdl.impl;

import java.lang.reflect.InvocationTargetException;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.WrappedException;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.etsi.mts.tdl.AtomicBehaviour;
import org.etsi.mts.tdl.Behaviour;
import org.etsi.mts.tdl.ComponentInstance;
import org.etsi.mts.tdl.ComponentInstanceBinding;
import org.etsi.mts.tdl.ParameterBinding;
import org.etsi.mts.tdl.TestDescription;
import org.etsi.mts.tdl.TestDescriptionReference;
import org.etsi.mts.tdl.tdlPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Test Description Reference</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link org.etsi.mts.tdl.impl.TestDescriptionReferenceImpl#getTestDescription <em>Test Description</em>}</li>
 *   <li>{@link org.etsi.mts.tdl.impl.TestDescriptionReferenceImpl#getComponentInstanceBinding <em>Component Instance Binding</em>}</li>
 *   <li>{@link org.etsi.mts.tdl.impl.TestDescriptionReferenceImpl#getArgument <em>Argument</em>}</li>
 * </ul>
 *
 * @generated
 */
public class TestDescriptionReferenceImpl extends AtomicBehaviourImpl implements TestDescriptionReference
{
	/**
	 * The cached value of the '{@link #getTestDescription() <em>Test Description</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTestDescription()
	 * @generated
	 * @ordered
	 */
	protected TestDescription testDescription;

	/**
	 * The cached value of the '{@link #getComponentInstanceBinding() <em>Component Instance Binding</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getComponentInstanceBinding()
	 * @generated
	 * @ordered
	 */
	protected EList<ComponentInstanceBinding> componentInstanceBinding;

	/**
	 * The cached value of the '{@link #getArgument() <em>Argument</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getArgument()
	 * @generated
	 * @ordered
	 */
	protected EList<ParameterBinding> argument;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TestDescriptionReferenceImpl()
	{
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass()
	{
		return tdlPackage.Literals.TEST_DESCRIPTION_REFERENCE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public TestDescription getTestDescription()
	{
		if (testDescription != null && testDescription.eIsProxy())
		{
			InternalEObject oldTestDescription = (InternalEObject)testDescription;
			testDescription = (TestDescription)eResolveProxy(oldTestDescription);
			if (testDescription != oldTestDescription)
			{
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, tdlPackage.TEST_DESCRIPTION_REFERENCE__TEST_DESCRIPTION, oldTestDescription, testDescription));
			}
		}
		return testDescription;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TestDescription basicGetTestDescription()
	{
		return testDescription;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setTestDescription(TestDescription newTestDescription)
	{
		TestDescription oldTestDescription = testDescription;
		testDescription = newTestDescription;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, tdlPackage.TEST_DESCRIPTION_REFERENCE__TEST_DESCRIPTION, oldTestDescription, testDescription));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<ComponentInstanceBinding> getComponentInstanceBinding()
	{
		if (componentInstanceBinding == null)
		{
			componentInstanceBinding = new EObjectContainmentEList<ComponentInstanceBinding>(ComponentInstanceBinding.class, this, tdlPackage.TEST_DESCRIPTION_REFERENCE__COMPONENT_INSTANCE_BINDING);
		}
		return componentInstanceBinding;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<ParameterBinding> getArgument()
	{
		if (argument == null)
		{
			argument = new EObjectContainmentEList<ParameterBinding>(ParameterBinding.class, this, tdlPackage.TEST_DESCRIPTION_REFERENCE__ARGUMENT);
		}
		return argument;
	}

	/**
	 * The cached invocation delegate for the '{@link #getParticipatingComponents() <em>Get Participating Components</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getParticipatingComponents()
	 * @generated
	 * @ordered
	 */
	protected static final EOperation.Internal.InvocationDelegate GET_PARTICIPATING_COMPONENTS__EINVOCATION_DELEGATE = ((EOperation.Internal)tdlPackage.Literals.TEST_DESCRIPTION_REFERENCE___GET_PARTICIPATING_COMPONENTS).getInvocationDelegate();

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public EList<ComponentInstance> getParticipatingComponents()
	{
		try
		{
			return (EList<ComponentInstance>)GET_PARTICIPATING_COMPONENTS__EINVOCATION_DELEGATE.dynamicInvoke(this, null);
		}
		catch (InvocationTargetException ite)
		{
			throw new WrappedException(ite);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
	{
		switch (featureID)
		{
			case tdlPackage.TEST_DESCRIPTION_REFERENCE__COMPONENT_INSTANCE_BINDING:
				return ((InternalEList<?>)getComponentInstanceBinding()).basicRemove(otherEnd, msgs);
			case tdlPackage.TEST_DESCRIPTION_REFERENCE__ARGUMENT:
				return ((InternalEList<?>)getArgument()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType)
	{
		switch (featureID)
		{
			case tdlPackage.TEST_DESCRIPTION_REFERENCE__TEST_DESCRIPTION:
				if (resolve) return getTestDescription();
				return basicGetTestDescription();
			case tdlPackage.TEST_DESCRIPTION_REFERENCE__COMPONENT_INSTANCE_BINDING:
				return getComponentInstanceBinding();
			case tdlPackage.TEST_DESCRIPTION_REFERENCE__ARGUMENT:
				return getArgument();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue)
	{
		switch (featureID)
		{
			case tdlPackage.TEST_DESCRIPTION_REFERENCE__TEST_DESCRIPTION:
				setTestDescription((TestDescription)newValue);
				return;
			case tdlPackage.TEST_DESCRIPTION_REFERENCE__COMPONENT_INSTANCE_BINDING:
				getComponentInstanceBinding().clear();
				getComponentInstanceBinding().addAll((Collection<? extends ComponentInstanceBinding>)newValue);
				return;
			case tdlPackage.TEST_DESCRIPTION_REFERENCE__ARGUMENT:
				getArgument().clear();
				getArgument().addAll((Collection<? extends ParameterBinding>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID)
	{
		switch (featureID)
		{
			case tdlPackage.TEST_DESCRIPTION_REFERENCE__TEST_DESCRIPTION:
				setTestDescription((TestDescription)null);
				return;
			case tdlPackage.TEST_DESCRIPTION_REFERENCE__COMPONENT_INSTANCE_BINDING:
				getComponentInstanceBinding().clear();
				return;
			case tdlPackage.TEST_DESCRIPTION_REFERENCE__ARGUMENT:
				getArgument().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID)
	{
		switch (featureID)
		{
			case tdlPackage.TEST_DESCRIPTION_REFERENCE__TEST_DESCRIPTION:
				return testDescription != null;
			case tdlPackage.TEST_DESCRIPTION_REFERENCE__COMPONENT_INSTANCE_BINDING:
				return componentInstanceBinding != null && !componentInstanceBinding.isEmpty();
			case tdlPackage.TEST_DESCRIPTION_REFERENCE__ARGUMENT:
				return argument != null && !argument.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedOperationID(int baseOperationID, Class<?> baseClass)
	{
		if (baseClass == Behaviour.class)
		{
			switch (baseOperationID)
			{
				case tdlPackage.BEHAVIOUR___GET_PARTICIPATING_COMPONENTS: return tdlPackage.TEST_DESCRIPTION_REFERENCE___GET_PARTICIPATING_COMPONENTS;
				default: return super.eDerivedOperationID(baseOperationID, baseClass);
			}
		}
		if (baseClass == AtomicBehaviour.class)
		{
			switch (baseOperationID)
			{
				case tdlPackage.ATOMIC_BEHAVIOUR___GET_PARTICIPATING_COMPONENTS: return tdlPackage.TEST_DESCRIPTION_REFERENCE___GET_PARTICIPATING_COMPONENTS;
				default: return super.eDerivedOperationID(baseOperationID, baseClass);
			}
		}
		return super.eDerivedOperationID(baseOperationID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eInvoke(int operationID, EList<?> arguments) throws InvocationTargetException
	{
		switch (operationID)
		{
			case tdlPackage.TEST_DESCRIPTION_REFERENCE___GET_PARTICIPATING_COMPONENTS:
				return getParticipatingComponents();
		}
		return super.eInvoke(operationID, arguments);
	}

} //TestDescriptionReferenceImpl
